<?php

class p_link2video_ext extends cmsPlugin {

    public function __construct(){
        
        $this->info['plugin']      = 'p_link2video_ext';
        $this->info['title']       = 'Замена YouTube ссылок на видео';
        $this->info['description'] = 'Замена YouTube ссылок на видео';
		$this->info['author']      = '<a target="_blank" href="http://www.instantcms.ru/users/Pasha"><strong style="color:#f60">Pasha</strong></a>';
        $this->info['version']     = '1.07';

		$this->events[] = 'GET_COMMENTS';
    	$this->events[] = 'GET_WALL_POSTS';
		$this->events[] = 'GET_FORUM_POSTS';
		$this->events[] = 'GET_POSTS';
		$this->events[] = 'GET_POST';
		$this->events[]	= 'EDITING_ARTICLE';// В /admin/applets/content.php и /components/content/frontend.php добавил три эвента чтобы подключить обработку статей (образец в mss-fin)
		
        $this->config['comments_show_video'] = 0;// Если 1, то вместо ссылки будет показано видео.
		$this->config['wall_show_video']     = 0;
		$this->config['forum_show_video']    = 0;
		$this->config['post_show_video']     = 0;
		$this->config['posts_show_video']    = 0;
		$this->config['article_show_video']  = 0;
        
		parent::__construct();
	}

    public function execute($event = '', $item = array()){

		$this->inPage->addHeadCSS('plugins/p_link2video_ext/style.css');
		$this->inPage->addHeadJS('plugins/p_link2video_ext/init.js');
		
		$html = ($event=='GET_FORUM_POSTS' || $event=='GET_POST' || $event=='GET_POSTS') ? 'content_html' : 'content';
		
		$player = '<div class="youtube_video">';
		$player.= $event=='EDITING_ARTICLE' ? '<iframe src="//www.youtube.com/embed/$4?rel=0"></iframe>' : '<iframe src="//www.youtube.com/embed/$5?rel=0"></iframe>';
		$player.= '</div>';

		$thumb = $event=='EDITING_ARTICLE' ? '<a class="youtube_video_link" href="http://www.youtube.com/embed/$4?rel=0&amp;wmode=transparent&amp;autoplay=1"><img src="http://img.youtube.com/vi/$4/mqdefault.jpg" alt="" /><span>Смотреть</span></a>' : '<a class="youtube_video_link" href="http://www.youtube.com/embed/$5?rel=0&amp;wmode=transparent&amp;autoplay=1"><img src="http://img.youtube.com/vi/$5/mqdefault.jpg" alt="" /><span>Смотреть</span></a>';

		$regexp = $event=='EDITING_ARTICLE' ? '!(http:\/\/|https:\/\/)?(www\.)?(youtube.com\/watch\?v=|youtu.be\/)([-\w]*)(\S*)!i' : '!(<a.+?href="\/go\/url=[^>]*>)(http:\/\/|https:\/\/)?(www\.)?(youtube.com\/watch\?v=|youtu.be\/)([-\w]*)(\S*</a>)!i';
		
		if(($event=='GET_COMMENTS' && $this->config['comments_show_video']) || ($event=='GET_WALL_POSTS' && $this->config['wall_show_video']) || ($event=='GET_FORUM_POSTS' && $this->config['forum_show_video']) || ($event=='GET_POSTS' && $this->config['posts_show_video']) || ($event=='GET_POST' && $this->config['post_show_video']) || ($event=='EDITING_ARTICLE' && $this->config['article_show_video'])){
			$replace = $player;
		} else {
			$replace = $thumb;
		}

		if($event=='GET_POST' || $event=='EDITING_ARTICLE'){
            //$item[$html] = str_replace("feature=player_embedded&", "", htmlspecialchars_decode($item[$html]));
			$item[$html] = preg_replace($regexp, $replace, $item[$html]);
		} else {
			for($i = 0; $i < count($item); $i++){
                //$item[$i][$html] = str_replace("feature=player_embedded&", "", htmlspecialchars_decode($item[$i][$html]));
				$item[$i][$html] = preg_replace($regexp, $replace, $item[$i][$html]);
			}
    	}

		return $item;
    }

}
